spring boot 学习(异常处理)

此文做记录交流,如有不当,还望指正。

全局异常处理

SpringBoot的全局异常处理有几种方式,我们这边只讨论@ControllerAdvice注解的方式去处理,@ControllerAdvice 需要和@ExcptionHandle配合使用

直接上代码,在我们之前的项目基础上创建一个全局异常处理类!

package com.demo.springboot_helloword.excetion;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;

@ControllerAdvice
public class GlobalException {
    @ExceptionHandler(Exception.class)
    public String resolvcerExcetion(HttpServletRequest reqeust, HttpServletResponse response, Exception e) {
        e.printStackTrace();
        return "plat_error";
    }
}

如上代码会对我们项目中的所有Controller的抛出异常进行处理,我们创建一个Controller

package com.demo.springboot_helloword.web;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

@Controller
public class HelloController {
    @RequestMapping("/hello")
    public String hello() throws Exception {
        throw new Exception("抛出异常");
    }

    @RequestMapping("/helloTry")
    public String helloTry() {
        try {
            throw new Exception("抛出异常");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return "hello";
    }
}

最后在/src/main/resource/templates下面创建 plat_error.ftl页面
在页面中增加一行字"握手controller异常"

好了,我们启动项目访问看看效果!
http://localhost:8080/hello

image.png

http://localhost:8080/helloTry

image.png

我们发现我们访问hello,确实按照我们的想法跳到了plat_error.ftl 页面,但是访问helloTry却没有跳转到异常页面,那是因为helloTry的异常我们没有抛出而是自己处理了,我们在catch中加上抛出代码就ok了

package com.demo.springboot_helloword.web;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

@Controller
public class HelloController {
    @RequestMapping("/hello")
    public String hello() throws Exception {
        throw new Exception("抛出异常");
    }

    @RequestMapping("/helloTry")
    public String helloTry() throws Exception {
        try {
            throw new Exception("抛出异常");
        } catch (Exception e) {
            e.printStackTrace();
            throw e;
        }
    }
}

重启项目后,我们再次访问helloTry,结果如下


image.png

我们发现已经正常跳转到 plat_error.ftl 页面

404

对于404,springboot不会把异常抛出,我们对于404有两种处理方式

第一种

更改springboot默认的404页面

package com.demo.springboot_helloword.config;

import org.springframework.boot.context.embedded.ConfigurableEmbeddedServletContainer;
import org.springframework.boot.context.embedded.EmbeddedServletContainerCustomizer;
import org.springframework.boot.web.servlet.ErrorPage;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.HttpStatus;

@Configuration
public class ErrorPageConfigration  {
    @Bean
    public EmbeddedServletContainerCustomizer containerCustomizer() {
 
        return new EmbeddedServletContainerCustomizer() {
            @Override
            public void customize(ConfigurableEmbeddedServletContainer container) {
                // TODO Auto-generated method stub
                ErrorPage error404Page = new ErrorPage(HttpStatus.NOT_FOUND, "/404");
                container.addErrorPages(error404Page);
            }
        };
    }
}

创建ErrorController

package com.demo.springboot_helloword.web;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

@Controller
public class ErrorController {
   @RequestMapping("/404")
   public String  error404(){
       return "404";
   }
}

在/src/main/resources/templates 下面创建一个名称为404.ftl内容为404的页面

我们访问一个不存在的链接看看效果


image.png

如图所示,跳转到了我们配置的404页面

第二种

我们需要在application.properties中进行配置让spring对404异常进行抛出

spring.mvc.throw-exception-if-no-handler-found=true
spring.resources.add-mappings=false

在异常处理中增加404的异常处理

package com.demo.springboot_helloword.excetion;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.servlet.NoHandlerFoundException;

@ControllerAdvice
public class GlobalException {
    @ExceptionHandler(NoHandlerFoundException.class)
    @ResponseStatus(HttpStatus.NOT_FOUND)
    public String resolvcerExcetion404(HttpServletRequest reqeust, HttpServletResponse response, Exception e) {
        e.printStackTrace();
        return "4041";
    }

    @ExceptionHandler(Exception.class)
    public String resolvcerExcetion(HttpServletRequest reqeust, HttpServletResponse response, Exception e) {
        e.printStackTrace();
        return "plat_error";
    }

}

在/src/main/resources/templates 下面创建一个名称为4041.ftl内容为4041的页面

配置完成后,我们访问一个不存在的连接看看效果

image.png

对页面访问和对REST访问分开处理

我们在开发的过程中往往会遇到对于请求返回页面的处理和请求返回数据的处理,而对于请求返回页面还是请求返回数据Spring Boot 分别采用不同的注解方式
@Controller 注解的类如果类或者方法上没有加特殊注解的情况下,默认返回面(如类或者方法上加上@ResponseBody注解则代表直接返回数据,而不返回页面)
@RestController 注解代表此类是一个RESTFULL接口类,只返回数据,不返回页面,此注解相当于 @Contrller + @RestController

我们有多种方式处理此种错误,我们这边讨论 《自定义异常处理》和《采用分包的方式处理》这两种处理方式分别利用@ControllerAdvice注解的 basePackages参数 @ExceptionHandler的exception参数

自定义异常处理

首先我们先创建一个异常类的存放包,这个包可以不用被扫描到


image.png

再创建两个异常类 ControllerException,RestControllerException

package com.demo.springboot_helloword.common.excetion;

public class ControllerException extends Exception {

    /**
     * 
     */
    private static final long serialVersionUID = 9221631863722129737L;

    public ControllerException(String message) {
        super(message);
        // TODO Auto-generated constructor stub
    }

    
}

package com.demo.springboot_helloword.common.excetion;

public class RestControllerException extends Exception {

    /**
     * 
     */
    private static final long serialVersionUID = 1222435350189491362L;
    public RestControllerException(String message) {
        super(message);
        // TODO Auto-generated constructor stub
    }

}

创建RestController并生成方法抛出RestControllerException

package com.demo.springboot_helloword.web;

import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.demo.springboot_helloword.common.excetion.RestControllerException;

@RestController
public class RestHelloController {
    @RequestMapping("/restHello")
    public String restHello() throws RestControllerException {
        throw new RestControllerException("restExcrption");
    }
}

修改HelloController 中 hello方法抛出ControllerException异常

package com.demo.springboot_helloword.web;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

import com.demo.springboot_helloword.common.excetion.ControllerException;

@Controller
public class HelloController {
    @RequestMapping("/hello")
    public String hello() throws ControllerException {
        throw new ControllerException("抛出异常");
    }

    @RequestMapping("/helloTry")
    public String helloTry() throws Exception {
        try {
            throw new Exception("抛出异常");
        } catch (Exception e) {
            e.printStackTrace();
            throw e;
        }
    }
}

在GlobalException中添加两个方法,分别处理ControllerException 异常和RestControllerException 异常

package com.demo.springboot_helloword.excetion;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.servlet.NoHandlerFoundException;

import com.demo.springboot_helloword.common.excetion.ControllerException;
import com.demo.springboot_helloword.common.excetion.RestControllerException;

@ControllerAdvice
public class GlobalException {
    @ExceptionHandler(NoHandlerFoundException.class)
    @ResponseStatus(HttpStatus.NOT_FOUND)
    public String resolvcerExcetion404(HttpServletRequest reqeust, HttpServletResponse response, Exception e) {
        e.printStackTrace();
        return "4041";
    }
    @ExceptionHandler(ControllerException.class)
    public String resolvcerControllerException(HttpServletRequest reqeust, HttpServletResponse response, Exception e) {
        e.printStackTrace();
        return "plat_error";
    }
    @ExceptionHandler(RestControllerException.class)
    @ResponseBody
    public String resolvcerRestControllerException(HttpServletRequest reqeust, HttpServletResponse response, Exception e) {
        e.printStackTrace();
        return "plat_error";
    }
    @ExceptionHandler(Exception.class)
    public String resolvcerExcetion(HttpServletRequest reqeust, HttpServletResponse response, Exception e) {
        e.printStackTrace();
        return "plat_error";
    }

}

好了,现在我们访问 http://localhost:8080/hello 看看

image.png

我们发现已经成功的返回了error页面
再访问http://localhost:8080/restHello 试试
image.png

如图,我们发现返回的使我们定义的字符串

分包方式处理

首先我们分别创建一个包,包用来放我们的RestController


image.png

如图所示

更改所有Controller中抛出异常为Exception

package com.demo.springboot_helloword.web;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

@Controller
public class HelloController {
    @RequestMapping("/hello")
    public String hello() throws Exception {
        throw new Exception("抛出异常");
    }

    @RequestMapping("/helloTry")
    public String helloTry() throws Exception {
        try {
            throw new Exception("抛出异常");
        } catch (Exception e) {
            e.printStackTrace();
            throw e;
        }
    }
}
package com.demo.springboot_helloword.webrest;

import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class RestHelloController {
    @RequestMapping("/restHello")
    public String restHello() throws Exception {
        throw new Exception("restExcrption");
    }
}

在exception包中增加RestGlobalException 如图


image.png

RestGlobalException 代码

package com.demo.springboot_helloword.excetion;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

@RestControllerAdvice(basePackages = "com.demo.springboot_helloword.webrest")
public class RestGlobalException {
    @ExceptionHandler(Exception.class)
    public String resolvcerExcetion(HttpServletRequest request, HttpServletResponse response, Exception e) {
        return "restExcetion";
    }
}

对GlobalException 做如下更改

package com.demo.springboot_helloword.excetion;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.servlet.NoHandlerFoundException;

import com.demo.springboot_helloword.common.excetion.ControllerException;
import com.demo.springboot_helloword.common.excetion.RestControllerException;

@ControllerAdvice(basePackages="com.demo.springboot_helloword.web")
public class GlobalException {
//  @ExceptionHandler(NoHandlerFoundException.class)
//  @ResponseStatus(HttpStatus.NOT_FOUND)
//  public String resolvcerExcetion404(HttpServletRequest reqeust, HttpServletResponse response, Exception e) {
//      e.printStackTrace();
//      return "4041";
//  }
//  @ExceptionHandler(ControllerException.class)
//  public String resolvcerControllerException(HttpServletRequest reqeust, HttpServletResponse response, Exception e) {
//      e.printStackTrace();
//      return "plat_error";
//  }
//  @ExceptionHandler(RestControllerException.class)
//  @ResponseBody
//  public String resolvcerRestControllerException(HttpServletRequest reqeust, HttpServletResponse response, Exception e) {
//      e.printStackTrace();
//      return "plat_error";
//  }
    @ExceptionHandler(Exception.class)
    public String resolvcerExcetion(HttpServletRequest reqeust, HttpServletResponse response, Exception e) {
        e.printStackTrace();
        return "plat_error";
    }

}

然后启动项目,分别访问
http://localhost:8080/hello
http://localhost:8080/restHello

效果如下


image.png
image.png

推荐阅读更多精彩内容